
#include <Adafruit_CircuitPlayground.h>

#if !defined(ARDUINO_SAMD_CIRCUITPLAYGROUND_EXPRESS)
  #error "Infrared support is only for the Circuit Playground Express, it doesn't work with the Classic version"
#endif


/* IR signals consist of a protocol number, a value, and a number of bits.
 *  Store all of these values for future use.
 */

//each number in the remote is used.
//to knoe that is the codes i used IR_read sketch
#define MY_PROTOCOL NECX
#define MY_BITS 32
#define ZERO 0xEF00FF
#define ONE 0xEF807F
#define TWO 0xEF40BF
#define THREE 0xEFC03F
#define FOUR 0xEF20DF
#define FIVE 0xEFA05F
#define SIX 0xEF609F
#define SEVEN 0xEFE01F
#define EIGHT 0xEF10EF
#define NINE 0xEF906F
#define DEL 0xEFA857
#define OK 0xEFE817




String getWorkerID() {
  /*  Receiver will look for a signal and when wa complete frame of data
   *   has been received, getResults() returns true. Once that happens,
   *   the receiver stops reccording  so you will need to restart it
   *   after you have processed the data.
   */
    Serial.print("getWorkerID function ");
  String workerId = "";
  CircuitPlayground.irReceiver.enableIRIn();
  uint32_t IR_value = 0;
  while(IR_value != OK){
     if(CircuitPlayground.irReceiver.getResults()) {
    //attempt to decode it
    if(CircuitPlayground.irDecoder.decode()) {
        CircuitPlayground.irDecoder.dumpResults(false);
        IR_value= CircuitPlayground.irDecoder.value;
        switch(IR_value){
              case ZERO:
                  workerId +=0;
                  break;
            
              case ONE:
                    workerId +=1;
                    break;
              
              case TWO:
                    workerId +=2;
                    break;
              
              case THREE:
                    workerId +=3;
                    break;
              
              case FOUR:
                    workerId +=4;
                    break;
              case FIVE:
                    workerId +=5;
                    break;      
              
              case SIX:
                    workerId +=6;
                    break;
              
              case SEVEN:
                    workerId +=7;
                    break;
              
              case EIGHT:
                    workerId +=8;
                    break;
              
              case NINE:
                    workerId +=9;
                    break;
              
              case DEL:
                    workerId= remove_last_char(workerId);
                    break;
              
               default:
                    break;
            }
            Serial.println(workerId);
    }
    CircuitPlayground.irReceiver.enableIRIn();      //Restart receiver
  }
  }
  
  return workerId;
}

String remove_last_char(String str){
  if (str.length() == 0)return "";
  Serial.print("remove last char");
  String new_str = "";
  for(int i=0; i < str.length()-1; i++){
    new_str+=str[i];
  }
  return new_str;
}
